【代码随想录算法训练营第五十一天|115.不同的子序列、583. 两个字符串的删除操作、72.编辑距离】

文章目录

115.不同的子序列

dp数组表示s和t中前i-1和j-1项中s中出现过的t的次数,递推公式中当选择到s的第i-1的元素和tj-1相等时,需要考虑两种情况,第一种是选择用si-1这个元素和tj-1匹配,那么dpij就应该是dpi-1j-1,如果不使用si-1的话,就应该是和dpi-1j相同,因此dp[i][j] = dp[i-1][j-1] + dp[i-1][j]。当si-1不等于tj-1时,就相当于是不使用si-1和t:j匹配的情况,因此赋值为dpi-1j。

python 复制代码
class Solution:
    def numDistinct(self, s: str, t: str) -> int:
        len1 = len(s)
        len2 = len(t)
        dp = [[0]* (len2+1) for _ in range(len1+1)] # dp[i][j] 前一位是s后一位是t,t不变在s中删减,当t=''的时候dp[i][0]应该为1 
        for d in dp:
            d[0] = 1
        for i in range(1, len1+1):
            for j in range(1, len2+1):
                if s[i-1] == t[j-1]:
                    dp[i][j] = dp[i-1][j-1] + dp[i-1][j]
                else:
                    dp[i][j] = dp[i-1][j]
        return dp[-1][-1]

583. 两个字符串的删除操作

其实就是找两个数组相同的公共子序列长度,最后输出的时候拿两个数组的长度和减去两倍的最大公共子序列长度就可以。

python 复制代码
class Solution:
    def minDistance(self, word1: str, word2: str) -> int:
        len1 = len(word1)
        len2 = len(word2)
        dp = [[0]*(len2+1) for _ in range(len1+1)] # dp[i][j]表示word1选择前i位,word2选择前j位的时候两个字符串相同字符的个数
        for i in range(1, len1+1):
            for j in range(1, len2+1):
                if word1[i-1] == word2[j-1]:
                    dp[i][j] = dp[i-1][j-1] + 1
                else:
                    dp[i][j] = max(dp[i-1][j], dp[i][j-1])
        return len1 + len2 - 2*dp[-1][-1]

72.编辑距离

本质上还是在找两个字符串的最长相同子序列,这里的增加操作和删除操作其实可以看作是同一种操作,只是在两个字符串上反过来,因此需要增加一个字符也可以看作是另一个字符种删除掉这个字符,所以当word1和word2的字符i和j不相等的时候,dpij在dpi-1j即删除word1元素,dpij-1即删除word2元素,和dpi-1j-1即替换元素中选择最小的,然后+1。还有一个重要的是初始dp的时候需要对所有一个为空另一个不为空的时候的dp赋予初值,初值就是那个字符串的长度。

python 复制代码
class Solution:
    def minDistance(self, word1: str, word2: str) -> int:
        len1 = len(word1)
        len2 = len(word2)
        dp =[[0] * (len2+1) for _ in range(len1+1)]
        for i in range(len1+1):
            dp[i][0] = i
        for j in range(len2+1):
            dp[0][j] = j
        for i in range(1, len1+1):
            for j in range(1, len2+1):
                if word1[i-1] == word2[j-1]:
                    dp[i][j] = dp[i-1][j-1]
                else:
                    dp[i][j] = min(dp[i-1][j], dp[i][j-1], dp[i-1][j-1]) + 1
        return dp[-1][-1]
相关推荐
曹牧2 分钟前
VS: Visual Studio 里把未包含的文件加进项目2
linux·运维·算法
重生之小比特20 分钟前
【算法拾光】滑动窗口|长度最小的子数组 + 无重复字符的最长子串
算法
weixin_3077791326 分钟前
C++代码实现MATLAB中的fitnlm函数功能
开发语言·c++·算法·matlab
雪落漂泊30 分钟前
C++算法:双指针篇(下)
数据结构·c++·算法
生态学者10 小时前
Global Change Biology | 森林越“步调一致”,反而越怕干旱?树木生长与叶片活动的同步之谜
大数据·人工智能·算法·r语言·微信公众平台
lsswear10 小时前
Agent 框架新手入门与实战部署指南
大数据·人工智能·算法
Data analyse45612 小时前
rnweb 回放数据量太大怎么办?分片存储与断点续传的实现思路
前端·网络·算法·数据分析
Navigator_Z13 小时前
LeetCode //C - 1293. Shortest Path in a Grid with Obstacles Elimination
c语言·算法·leetcode
Nil20814 小时前
leetcode 64最小路径和
算法·leetcode·职场和发展
光影少年14 小时前
AI Agent、自动化与未来工作
人工智能·算法·架构